## openjpeg 1.5.2

=== applications/CMakeLists.txt ===
# Build the each application if it needed

IF(BUILD_CODEC)
  ADD_SUBDIRECTORY(codec)
ENDIF(BUILD_CODEC)

IF(BUILD_MJ2)
  ADD_SUBDIRECTORY(mj2)
ENDIF(BUILD_MJ2)

# Client & Server:
IF(BUILD_JPIP)
  ADD_SUBDIRECTORY(jpip)
ENDIF(BUILD_JPIP)

IF(BUILD_VIEWER)
  ADD_SUBDIRECTORY(OPJViewer)
ENDIF(BUILD_VIEWER)

IF(BUILD_JAVA)
	ADD_SUBDIRECTORY(JavaOpenJPEG)
ENDIF(BUILD_JAVA)
