=== debian/changelog ===
openjpeg (1:1.5.2-3.1) unstable; urgency=high

  * Non-maintainer upload.
  * Apache 2.4 transition: (Closes: #786332)
    - d/openjpip.conf: Changed documentroot path to /var/www/html;
      changed localhost by 127.0.0.1 to support ipv6 enabled hosts.
    - Use dh_apache2:
      . d/rules: Added --with apache2.
      . d/openjpip-server.install: Drop installs to /etc/apache2/mods-available
      . Drop d/openjpip-server.prerm.
      . d/control: Add build-depends on dh-apache2, replace depends on
        apache2.2-bin by ${misc:Recommends}, add recommends on
        libapache2-mod-fastcgi.
      . New d/openjpip-server.apache2 to set up the configuration.
      . Install as a conf-available: Renamed openjpip.conf to
        openjpip-server.conf, removed openjpip.load, new maintscript.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Wed, 20 May 2015 21:52:22 +0200

openjpeg (1:1.5.2-3) unstable; urgency=medium

  * epoch upload to resolve #760874 completely

 -- Mathieu Malaterre <malat@debian.org>  Sat, 04 Oct 2014 13:51:19 +0200

openjpeg (1.5.2-2) unstable; urgency=low

  * Remove patch applied upstream already
    - d/p/fixjnisoname.patch
  * Really fix java compilation. Closes: #741915
  * Use system installed getopt. Closes: #716594
  * Update d/copyright. Closes: #697806

 -- Mathieu Malaterre <malat@debian.org>  Tue, 01 Apr 2014 13:38:56 +0000

openjpeg (1.5.2-1) unstable; urgency=low

  * New upstream.
    Closes: #731237, #697806, #716594, #716595, #741915, #741974, #741916
  * Update watch file to now point to sf.net mirror

 -- Mathieu Malaterre <malat@debian.org>  Thu, 27 Mar 2014 20:19:41 +0100

openjpeg (1.5.1-3) unstable; urgency=low

  * Fix cmake monolithic export.
  * Prefer build type of None
  * B-D on libtiff-dev. Closes: #736034

 -- Mathieu Malaterre <malat@debian.org>  Mon, 17 Mar 2014 18:45:54 +0100

openjpeg (1.5.1-2) unstable; urgency=low

  * Upload to sid
  * Import patch from upstream to prevent regression from 1.5.0:
    d/p/issue205.patch

 -- Mathieu Malaterre <malat@debian.org>  Mon, 17 Mar 2014 09:28:46 +0100

openjpeg (1.5.1-1) experimental; urgency=low

  * New upstream. Closes: #687528, #681458, #691156
  * Fix java binding installation
    - fixjniinstall.patch
  * Fix SONAME hack in d/rules, prefer cmake solution
    - fixjnisoname.patch
  * Remove patch applied upstream:
    - addmathlib.patch
    - fixsoname.patch
    - relativeincludepath.patch
    - installjava.patch
    - addxml2.patch
    - manpagetypo.patch

 -- Mathieu Malaterre <malat@debian.org>  Mon, 22 Oct 2012 12:51:26 +0200

openjpeg (1.5.0-3) experimental; urgency=low

  * Add missing jp2-thumbnailer
  * Mark packages with Multi-Arch: same/foreign

 -- Mathieu Malaterre <malat@debian.org>  Tue, 19 Jun 2012 16:46:59 +0200

openjpeg (1.5.0-2) experimental; urgency=low

  * Adding libopenjpeg-java. Closes: #510443
  * Update d/control so that it is easier to backport to stable
  * Provide a fix for cmake commit a2be068c
  * Provide a symlinks openjpeg.h -> openjpeg-1.5/openjpeg.h for easier
    transition
  * Add openjpip-server package: openjpip-server
   - Add init script
   - Fix default location of tempfile to be in /tmp
  * Add openjpip java based clients packages:
   - openjpip-viewer
   - openjpip-viewer-xerces

 -- Mathieu Malaterre <malat@debian.org>  Fri, 20 Apr 2012 11:45:07 +0200
