=== debian/control ===
Source: openjpeg
Priority: extra
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Robin Cornelius <robin.cornelius@gmail.com>
 , David Paleino <dapal@debian.org>
 , Mathieu Malaterre <malat@debian.org>
Homepage: http://www.openjpeg.org
Build-Depends:
 debhelper (>= 9)
 , dh-apache2
 , cmake (>= 2.8.0)
 , javahelper (>= 0.37~)
 , default-jdk
 , libxerces2-java
 , libtiff-dev
 , libpng-dev
 , liblcms2-dev
 , zlib1g-dev
 , libfcgi-dev
 , libcurl4-gnutls-dev | libcurl-ssl-dev
 , doxygen
Standards-Version: 3.9.5
Section: libs
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-phototools/openjpeg.git
Vcs-Git: git://anonscm.debian.org/pkg-phototools/openjpeg.git

Package: libopenjpeg-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libopenjpeg5 (= ${binary:Version})
 , ${misc:Depends}
Description: development files for OpenJPEG, a JPEG 2000 image library - dev
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This is the development package

Package: libopenjpeg5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
Description: JPEG 2000 image compression/decompression library - runtime
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 this is the runtime package

Package: libopenjpeg-java
Section: java
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, ${java:Depends}
Description: java bindings for libopenjpeg, a JPEG 2000 image library
 This package contains the java binding to match the runtime component of the
 OpenJPEG library, allowing java program to use OpenJPEG.
 .
 This is a Java bindings to the underlying OpenJPEG C implementation. This
 is not a full Java implementation.

Package: libopenjpeg5-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: libopenjpeg5 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for libopenjpeg5, a JPEG 2000 image library
 This package contains the debug symbols to match the runtime component of the
 OpenJPEG library, allowing debugging of a program using OpenJPEG to
 access debugging details within the library itself.

Package: openjpip-dec-server
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to allow caching of JPEG 2000 files using JPIP protocol
 This is client side application for caching remote JPEG 2000 using the JPIP
 protocol. This command line application needs to run on the client side to
 allow application such as opj_viewer or opj_viewer_xerces to view images.

Package: openjpip-viewer-xerces
Section: graphics
Architecture: all
Depends: ${misc:Depends}, ${java:Depends}, openjpip-dec-server
Description: JPEG 2000 java based viewer for advanced remote JPIP access
 Java based client to view remote JPEG 2000 using JPIP protocol.
 This is a simple java viewer to allow:
 .
  - Scale up request: Enlarge the window
  - ROI request: Select a region by mouse click and drag, then click inside the
    red frame of the selected region
  - Annotate image with ROI information in XML metadata: Click button "Region
    Of Interest"
  - Open a new window presenting an aligned image with a locally stored image:
    Click button "Image Registration" (Under Construction)

Package: openjpip-viewer
Section: graphics
Architecture: all
Depends: ${misc:Depends}, ${java:Depends}, openjpip-dec-server
Description: JPEG 2000 java based viewer for basic remote JPIP access
 Java based client to view remote JPEG 2000 using JPIP protocol.
 This is a simple java viewer to allow:
 .
  - Scale up request: Enlarge the window
  - ROI request: Select a region by mouse click and drag, then click inside the
    red frame of the selected region

Package: openjpip-server
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libwww-perl, spawn-fcgi (>= 1.6.1)
Recommends: ${misc:Recommends}, libapache2-mod-fastcgi
Description: JPIP server for JPEG 2000 files
 OpenJPIP software is an implementation of JPEG 2000 Part9: Interactivity tools,
 APIs and protocols (JPIP). For more info about JPIP, check the website:
 http://www.jpeg.org/jpeg2000/j2kpart9.html. The current implementation uses
 some results from the 2KAN project (http://www.2kan.org).
 .
 First Version 1.0 covers:
 .
  - JPT-stream (Tile based) and JPP-stream (Precinct based) media types
  - Session, channels, cache model managements
  - JPIP over HTTP
  - Indexing JPEG 2000 files
  - Embedding XML formatted metadata
  - Region Of Interest (ROI) requests

Package: openjpeg-tools
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command-line tools using the JPEG 2000 library
 This package provides with command-line tools allowing for conversions between
 several formats and also provides tools for encoding and decoding
 motion-jpeg2000 video formats:
 .
  - j2k_to_image: decodes j2k, jp2, and jpt files to pgm, ppm, pnm,
                  pgx, and bmp.
  - image_to_j2k: encodes pnm, pgm, pgx, bmp, and ppm files to j2k,
                  and jp2.
  - index_create: create jp2 with JPIP index file from a j2k file.
  - frames_to_mj2: convert YUV video streams to mj2 format.
  - mj2_to_frames: convert mj2 video streams to YUV format.
  - wrap_j2k_in_mj2: wrap j2k codestreams into mj2 format.
  - extract-j2k-from_mj2: extract j2k codestreams from the mj2 format.
