=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CURVER := $(shell dpkg-parsechangelog | grep ^Version | awk '{print $$2}' | cut -d- -f1 | cut -d+ -f1)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
JAVA_HOME=/usr/lib/jvm/default-java

%:
	dh $@ --buildsystem=cmake --parallel --with javahelper,apache2

CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_RPATH=ON \
	-DCMAKE_BUILD_TYPE:STRING=None \
	-DOPENJPEG_INSTALL_LIB_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DOPENJPEG_INSTALL_JNI_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)/jni \
	-DBUILD_CODEC:BOOL=ON \
	-DBUILD_JPIP:BOOL=ON \
	-DBUILD_JPIP_SERVER:BOOL=ON \
	-DBUILD_JPWL:BOOL=ON \
	-DBUILD_JAVA:BOOL=ON \
	-DBUILD_MJ2:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DUSE_SYSTEM_GETOPT:BOOL=ON \
	-DBUILD_TESTING:BOOL=OFF \
	-DBUILD_THIRDPARTY:BOOL=OFF

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_strip:
	dh_strip --dbg-package=libopenjpeg5-dbg

override_dh_install:
	dh_install --list-missing

override_dh_installinit:
	dh_installinit -popenjpip-server --name=openjpip

# http://cmake.org/gitweb?p=cmake.git;a=commitdiff;h=a2be068c
override_dh_auto_install:
	sed -i -e "s/FATAL_ERROR/STATUS/g" ./obj-*/CMakeFiles/Export/lib/*/openjpeg-1.5/OpenJPEGTargets-none.cmake
	sed -i -e "s/FATAL_ERROR/STATUS/g" ./obj-*/CMakeFiles/Export/lib/*/openjpeg-1.5/OpenJPEGTargets.cmake
	dh_auto_install

get-orig-source:
	uscan --verbose --rename \
		--force-download \
		--download-version $(CURVER)

.PHONY: override_dh_auto_configure \
	override_dh_strip \
	get-orig-source
